import { DlDateAdapter } from './dl-date-adapter';
import { Moment } from 'moment';
/**
 * Adapts `moment` to be usable as a date by date/time components that work with dates.
 **/
export declare class DlDateAdapterMoment extends DlDateAdapter<Moment> {
    /**
     * Create a new instance of a `moment` type from milliseconds.
     * @param milliseconds
     *  a time value as milliseconds (local time zone)
     * @returns
     *  an instance of `moment` for the specified moment in time.
     */
    fromMilliseconds(milliseconds: number): Moment;
    /**
     * Returns a moment in time value as milliseconds (local time zone).
     * @param value
     *  a moment or `null`.
     * @returns
     *  a `moment.valueOf()` result for the specified `moment` or `null`
     */
    toMilliseconds(value: Moment | null): number | null;
}
