import { DlDateAdapter } from './dl-date-adapter';
import { InjectionToken } from '@angular/core';
/**
 * InjectionToken for string dates that can be used to override default output format.
 **/
export declare const DL_STRING_DATE_OUTPUT_FORMAT: InjectionToken<string>;
/**
 * InjectionToken for string dates that can be used to override default input formats.
 **/
export declare const DL_STRING_DATE_INPUT_FORMATS: InjectionToken<string[]>;
/**
 * Adapts `string` to be usable as a date by date/time components that work with dates.
 **/
export declare class DlDateAdapterString extends DlDateAdapter<string> {
    private readonly modelFormat;
    private readonly inputFormats;
    constructor(inputFormats: string[], modelFormat: string);
    /**
     * Returns the specified number.
     * @param milliseconds
     *  a moment time time.
     * @returns
     *  the specified moment in time.
     */
    fromMilliseconds(milliseconds: number): string;
    /**
     * Returns the specified number.
     * @param value
     *  a moment time time or `null`
     * @returns
     *  the milliseconds for the specified value or `null`
     *  `null` is returned when value is not a valid input date string
     */
    toMilliseconds(value: string | null): number | null;
}
